import { useEffect } from "react";
import { decode } from "@msgpack/msgpack";
import pako from "pako";
import * as cornerstone from "@cornerstonejs/core";
import dicomParser from "dicom-parser";
import cornerstoneWADOImageLoader from "cornerstone-wado-image-loader";
import axios from "axios";

interface DiffViewerProps {
  children?: JSX.Element;
}

export const DiffViewer = (props: DiffViewerProps) => {
  useEffect(() => {
    axios({
      url: "/py/get_reference_image",
      method: "get",
      responseType: "arraybuffer",
    })
      .then((response) => {
        const decompressedData = pako.inflate(new Uint8Array(response.data)); // Use pako to decompress the data
        const pixelArray1 = decode(decompressedData); // Decode the data using msgpack

        console.log(pixelArray1);

        // 请求compressed_data
        // for (let i = 2; i < 220; i++) {
        //   axios
        //     .get(`/py/get_compressed_data/${i}`)
        //     .then((response) => {
        //       const compressedData = response.data.compressed_data;

        //       // TODO: 根据需要进一步处理数据
        //     })
        //     .catch((error) => {
        //       console.error(
        //         `Error fetching compressed data for image ${i}:`,
        //         error
        //       );
        //     });
        // }
      })
      .catch((error) => {
        console.error("Error fetching reference image:", error);
      });
  }, []);

  useEffect(() => {
    cornerstoneWADOImageLoader.external.cornerstone = cornerstone;
    cornerstoneWADOImageLoader.webWorkerManager.initialize({
      maxWebWorkers: navigator.hardwareConcurrency || 1,
      startWebWorkersOnDemand: true,
      webWorkerPath: "/path/to/cornerstoneWADOImageLoaderWebWorker.js",
      taskConfiguration: {
        decodeTask: {
          codecsPath: "/path/to/cornerstoneWADOImageLoaderCodecs.js",
        },
      },
    });
  }, []);
  return <div>DiffViewer</div>;
};
